/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.entschaedigung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart;
import de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartUK;

public abstract class AbstractEntschaedigungsartDAO extends de.ivu.elect.jee.entity.AbstractDAO<Entschaedigungsart,
        de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK
    , EntschaedigungsartUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractEntschaedigungsartDAO.class);

  public AbstractEntschaedigungsartDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Entschaedigungsart findByPrimaryKey(
        de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Entschaedigungsart findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Entschaedigungsart.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlAndKriteriumPersonendatenArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM Entschaedigungsart obj WHERE obj.wahl = ?1 AND obj.kriteriumPersonendatenArt = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Entschaedigungsart> findByWahlAndKriteriumPersonendatenArt( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String kriteriumPersonendatenArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String kriteriumPersonendatenArtCheckedAndAttached =  checkAndAttach(kriteriumPersonendatenArt, String.class, "kriteriumPersonendatenArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ENTSCHAEDIGUNGSART.WahlAndKriteriumPersonendatenArt")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, kriteriumPersonendatenArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndKriteriumPersonendatenArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Entschaedigungsart, findByWahlAndKriteriumPersonendatenArt - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", kriteriumPersonendatenArt:'"+kriteriumPersonendatenArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndKriteriumPersonendatenArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM Entschaedigungsart obj WHERE obj.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<Entschaedigungsart> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ENTSCHAEDIGUNGSART.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Entschaedigungsart, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndKriteriumPersonendatenArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM Entschaedigungsart obj WHERE obj.wahltermin = ?1 AND obj.kriteriumPersonendatenArt = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Entschaedigungsart> findByWahlterminAndKriteriumPersonendatenArt( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String kriteriumPersonendatenArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String kriteriumPersonendatenArtCheckedAndAttached =  checkAndAttach(kriteriumPersonendatenArt, String.class, "kriteriumPersonendatenArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ENTSCHAEDIGUNGSART.WahlterminAndKriteriumPersonendatenArt")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, kriteriumPersonendatenArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndKriteriumPersonendatenArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Entschaedigungsart, findByWahlterminAndKriteriumPersonendatenArt - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", kriteriumPersonendatenArt:'"+kriteriumPersonendatenArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndKriteriumPersonendatenArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminDeleteNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Entschaedigungsart obj WHERE obj.wahltermin = ?1<br>
      * SQL: <br>
      */
     public Integer deleteWahlterminDelete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("ENTSCHAEDIGUNGSART.WahlterminDelete")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Entschaedigungsart, deleteWahlterminDelete - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteWahlterminDelete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM Entschaedigungsart obj WHERE obj.wahltermin = ?1<br>
      * SQL: <br>
      */
     public java.util.List<Entschaedigungsart> findByWahltermin( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ENTSCHAEDIGUNGSART.Wahltermin")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahltermin - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Entschaedigungsart, findByWahltermin - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahltermin(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartUK uk,
        de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart findByUK(de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}